<template>
  <div class="container">
    <div class="columns">
      <div class="column package-section top-actions">
        <div class="float-right">
          <!-- <button class="btn btn-package" @click="showSideModal">Use Package Template</button> -->
          <button class="btn btn-package" @click="addRow">Add Earnings</button>
        </div>
      </div>
    </div>
    <div class="columns">
      <div class="column package-section">
        <h5>Current Earnings</h5>
        <table class="table">
          <thead>
            <tr>
              <th>Type</th>
              <th>Rate</th>
              <th>Start</th>
              <th>End</th>
              <th>Frequency</th>
              <th>Basis</th>
              <th></th>
            </tr>
          </thead>
          <tbody ref="editable_table" v-if="earningsExist">
            <tr v-for="(e, index) in earnings" v-bind:key="index">
              <td>
                <span v-if="e.is_editable">
                  <select class="form-select" v-model="earning.type">
                    <option value="">Choose type</option>
                    <option v-for="type in types" v-bind:key="type">{{ type }}</option>
                  </select>
                </span>
                <span v-else>{{ e.type }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <input class="form-input" type="number" v-model="earning.rate"/>
                </span>
                <span v-else>{{ e.rate }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <input class="form-input" type="date" value="2016-12-31" v-model="earning.start" />
                </span>
                <span v-else>{{ e.start }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <input class="form-input" type="date" value="2016-12-31" v-model="earning.end" />
                </span>
                <span v-else>{{ e.end }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <select class="form-select" v-model="earning.frequency">
                    <option v-for="frequency in frequencies" v-bind:key="frequency">{{frequency}}</option>
                  </select>
                </span>
                <span v-else>{{ e.frequency }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <select class="form-select" v-model="earning.basis">
                    <option value="">Choose basis</option>
                    <option v-for="base in basis" v-bind:key="base">{{ base }}</option>
                  </select>
                </span>
                <span v-else>{{ e.basis }}</span>
              </td>
              <td>
                <span v-if="e.is_editable">
                  <span @click="addItem(index)"><img src="images/icons/content-save.svg" alt="Save icon" class="table_icon"/></span> |
                  <span @click="cancelItem(index)"><img src="images/icons/close-circle.svg" alt="Cancel icon" class="table_icon"/></span>
                </span>
                <div v-else>
                  <span @click="editRow(index)"><img src="images/icons/pencil-outline.svg" alt="Edit icon" class="table_icon"/></span> |
                  <span @click="deleteRow(index)"><img src="images/icons/delete-outline.svg" alt="Delete icon" class="table_icon"/></span>
                </div>
              </td>
            </tr>
          </tbody>
          <tbody ref="editable_table" v-else>
            <tr>
              <td class="empty-earnings" colspan="7">No data</td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <div class="columns">
      <div class="column package-section">
        <div class="float-right btm-actions">
          <button class="btn btn-package" @click="exportData">Submit Package</button>
        </div>
      </div>
    </div>
    <div class="" v-if="displaySide">
      <div class="modal-container container2" >
        <table class="table" id="list_package">
          <thead>
            <tr>
              <th>Tag</th>
              <th>Pay Frequency</th>
              <th>Pay Calculation Basis</th>
              <th>Rate Amount</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in earnings" v-bind:key="item.id">
              <td>{{item.id}}</td>
              <td>{{item.frequency}}</td>
              <td>{{item.calculation}}</td>
              <td>{{item.rate_amount}}</td>
            </tr>
          </tbody>
        </table>
        <div>
          <form id="submitNewPackage">
            <div class="columns">
              <div class="column col-4">
                <div class="form-group">
                  <label for="package" class="form-label">Package</label>
                  <select name="package" class="form-input f_space" v-on:change="getEarnings">
                    <option value>Select Package</option>
                    <option v-for="pack in packages" v-bind:value="pack.id" :key="pack.id">{{ pack.tag }}</option>
                  </select>
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group">
                  <label for="startDate" class="form-label">Start Date</label>
                  <input type="date" class="form-input f_space">
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group">
                  <label for="endDate" class="form-label">End Date</label>
                  <input type="date" class="form-input f_space">
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group t_space">
                  <button class="btn submit_btn">Add Package</button>
                </div>
              </div>
              <div class></div>
            </div>
          </form>
          <div class="t_space">
            <table class="table table-striped table-hover">
              <tr>
                <th>Type</th>
                <th>Frequency</th>
                <th>Basis</th>
                <th>Rate</th>
              </tr>
              <tr v-for="item in earnings" v-bind:key="item.id">
                <td>{{item.type}}</td>
                <td>{{item.pay_frequency}}</td>
                <td>{{item.pay_calculation_basis}}</td>
                <td>{{item.rate_amount}}</td>
              </tr>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import axios from "axios";
export default {
  props:["employeeId"],
  data() {
    return {
      basis: ["Daily", "Hourly", "Monthly"],
      displaySide: false,
      earning: {
        "type": "Salary",
        "start": "2019-05-03",
        "end": "2019-05-03",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0
      },
      earnings: [],
      frequencies: ["Daily", "Weekly", "Monthly", "Fortnightly"],
      packages: [],
      types: ["Salary", "Housing", "Transport"]
    }
  },
  computed: {
    earningsExist() {
      return this.earnings != null && this.earnings.length > 0
    }
  },
  methods: {
    addItem(index) {
      this.earnings[index].type = this.earning.type
      this.earnings[index].start = this.earning.start
      this.earnings[index].end = this.earning.end
      this.earnings[index].frequency = this.earning.frequency
      this.earnings[index].basis = this.earning.basis
      this.earnings[index].rate = this.earning.rate
      this.earnings[index].is_editable = false
      
      this.resetEarning()
    },
    addRow() {
      this.earnings.push({
        "type": "Salary",
        "start": "2019-05-03",
        "end": "2019-05-03",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0,
        "is_editable": true
      })
    },
    addType(event) {
      console.log(event.target.value)
    },
    cancelItem(index) {
      this.$set(this.earnings[index], 'is_editable', false)
    },
    deleteRow(index) {
      console.log("Delete + ", index)
    },
    editRow(index) {
      this.$set(this.earnings[index], 'is_editable', true)
      this.earning.type = this.earnings[index].type,
      this.earning.start = this.earnings[index].start,
      this.earning.end = this.earnings[index].end,
      this.earning.frequency = this.earnings[index].frequency,
      this.earning.basis = this.earnings[index].basis,
      this.earning.rate = this.earnings[index].rate
    },
    exportData() {
      console.log(this.earnings)
      var url = '/api/earnings'
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      const axios = require('axios');
      var params = {employee:this.employeeId, earning:this.earnings};
      // var params = {earning:[{basis: this.earnings[0].basis, type : this.earnings[0].type, frequency: this.earnings[0].frequency, rate : this.earnings[0].rate , start: this.earnings[0].start,  end: this.earnings[0].end }, {basis: this.earnings[0].basis, frequency: this.earnings[0].frequency, rate : this.earnings[0].rate, type : this.earnings[0].type  , start: this.earnings[0].start,  end: this.earnings[0].end }]}
      axios.post( url, params, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
      .then((response)=>{

      //console.log(response.data.employee.country)
      ;})
      // console.log(this.earnings)
    },
    getEarnings() {
      let self = this;
      axios.get(`/api/earnings/${this.employeeId}`)
      .then(function(response) {
        console.log(response.data);
        self.earnings = [...response.data]
      })
      .catch(function(error) {
        console.log(error);
      });
    },
    resetEarning() {
      this.earning.type = "Salary",
      this.earning.start = "2019-05-03",
      this.earning.end = "2019-05-03",
      this.earning.frequency = "Daily",
      this.earning.basis = "Monthly",
      this.earning.rate = 0
    },
  },
  mounted() {
    this.getEarnings();
  }
}
</script>
<style scoped>
 
</style>
